/**
 * Utitlity to manage orders 
 * @author Sushant Yadav
 * @version 1.0
 * @since 2021-02-11
 */

package utilities;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import com.google.gson.Gson;

import jakarta.servlet.http.HttpServletRequest;

public class Order {
	//Request URL
	private String paymentURL;
	//AuthenticationKey For Payment Provided By Gateway
	private String AuthenticationKey;
	//AuthenticationToken For Payment Provided By Gateway
	private String AuthenticationToken;
	//SecureHashKey For Payment Provided By Gateway
	private String SecureHashKey;
	//MerchantKeyId For Payment Provided By Gateway. 
	private String MerchantKeyId;
 	//RedirectUrl For CallBack Url.
	private String RedirectUrl;
	//Time Out For Curl Session.
	private int timeout;
	
	public Order() {
        //Initialize
    	this.paymentURL = "https://uatapi.payg.in/payment/api/order";
    	this.AuthenticationKey = "dcb3ef4d84254929a0e81f14c3ddefbf";
    	this.AuthenticationToken  = "cb11d695d23e4a78bef04b90519b4b30";
    	this.SecureHashKey  = "b29cd704083442e2ac2e73f903167da4";
    	this.MerchantKeyId = "7771";
    	this.RedirectUrl = "https://a2zfame.com";
    	this.timeout = 30;
    }
	
	//To generate random string
	private static String generateRandomString(int length) {
		return String.valueOf(new Date().getTime()).substring(0, length);
	}
	
	//To create order details
	public Process create(HttpServletRequest request) throws IOException {
		Map mapData = new HashMap();
		mapData.put("Merchantkeyid", this.MerchantKeyId);
		mapData.put("UniqueRequestId", Order.generateRandomString(10));
		
		Map uData = new HashMap();
		uData.put("UserDefined1", "");
		mapData.put("UserDefinedData", uData);
		
		SimpleDateFormat dt = new SimpleDateFormat("MMddyyyy");
		mapData.put("RequestDateTime", dt.format(new Date()));
		mapData.put("RedirectUrl", this.RedirectUrl);
		
		Map<String, String> tranData = new HashMap<String, String>();
		tranData.put("AcceptedPaymentTypes", "");
		tranData.put("PaymentType", "");
		tranData.put("SurchargeType", "");
		tranData.put("SurchargeValue", "");
		tranData.put("RefTransactionId", "");
		tranData.put("IndustrySpecificationCode", "");
		tranData.put("PartialPaymentOption", "");
		
		mapData.put("TransactionData", tranData);
		
		Map<String, String> custData = new HashMap<String, String>();
		Map<String, String> orderData = new HashMap<String, String>();
		Map<String, String> intgData = new HashMap<String, String>();
		
		for (Entry<String, String[]> entry : request.getParameterMap().entrySet()) {
		    String name = entry.getKey();
		    if (name.startsWith("CustomerData[")) {
		        String key = name.substring(name.indexOf('[') + 1, name.indexOf(']')); 
		        custData.put(key, entry.getValue()[0]);
		    }
		    else if (name.startsWith("OrderAmountData[")) {
		        String key = name.substring(name.indexOf('[') + 1, name.indexOf(']')); 
		        orderData.put(key, entry.getValue()[0]);
		    }
		    else if (name.startsWith("IntegrationData[")) {
		        String key = name.substring(name.indexOf('[') + 1, name.indexOf(']')); 
		        intgData.put(key, entry.getValue()[0]);
		    }
		}
		mapData.put("CustomerData", custData);
		mapData.put("OrderAmountData", orderData);
		mapData.put("IntegrationData", intgData);

		String auth = this.AuthenticationKey+":"+this.AuthenticationToken+":M:"+this.MerchantKeyId;
		
		String shellcmd = "curl -X POST -d \""+new Gson().toJson(mapData)+"\" "+this.paymentURL+"/create"+" -H \"Content-Type: application/json\" -H \"Authorization:  Basic "+Base64.getEncoder().encodeToString(auth.getBytes("utf-8"))+"\"";
		//System.out.println(shellcmd);
		return Runtime.getRuntime().exec(shellcmd);
	}
	
	//To update order details
	public Process update(HttpServletRequest request,int orderKeyID) throws IOException {
		Map mapData = new HashMap();
		mapData.put("Merchantkeyid", this.MerchantKeyId);
		mapData.put("UniqueRequestId", Order.generateRandomString(10));
		mapData.put("OrderKeyId", orderKeyID);
		
		Map uData = new HashMap();
		uData.put("UserDefined1", "");
		mapData.put("UserDefinedData", uData);
		
		SimpleDateFormat dt = new SimpleDateFormat("MMddyyyy");
		mapData.put("RequestDateTime", dt.format(new Date()));
		mapData.put("RedirectUrl", this.RedirectUrl);
		
		Map<String, String> tranData = new HashMap<String, String>();
		tranData.put("AcceptedPaymentTypes", "");
		tranData.put("PaymentType", "");
		tranData.put("SurchargeType", "");
		tranData.put("SurchargeValue", "");
		tranData.put("RefTransactionId", "");
		tranData.put("IndustrySpecificationCode", "");
		tranData.put("PartialPaymentOption", "");
		
		mapData.put("TransactionData", tranData);
		
		Map<String, String> custData = new HashMap<String, String>();
		
		for (Entry<String, String[]> entry : request.getParameterMap().entrySet()) {
		    String name = entry.getKey();
		    if (name.startsWith("CustomerData[")) {
		        String key = name.substring(name.indexOf('[') + 1, name.indexOf(']')); 
		        custData.put(key, entry.getValue()[0]);
		    }
		}
		mapData.put("CustomerData", custData);
		
		String auth = this.AuthenticationKey+":"+this.AuthenticationToken+":M:"+this.MerchantKeyId;
		String shellcmd = "curl -X POST -d \""+new Gson().toJson(mapData)+"\" "+this.paymentURL+"/Update"+" -H \"Content-Type: application/json\" -H \"Authorization:  Basic "+Base64.getEncoder().encodeToString(auth.getBytes("utf-8"))+"\"";
		return Runtime.getRuntime().exec(shellcmd);
	}
	
	//To get order details
	public Process enquire(HttpServletRequest request,int orderKeyID,String paymentType) throws IOException {
		Map mapData = new HashMap();
		mapData.put("Merchantkeyid", this.MerchantKeyId);
		mapData.put("OrderKeyID", orderKeyID);
		mapData.put("PaymentType", paymentType);
		
		String auth = this.AuthenticationKey+":"+this.AuthenticationToken+":M:"+this.MerchantKeyId;
		String shellcmd = "curl -X POST -d \""+new Gson().toJson(mapData)+"\" "+this.paymentURL+"/Detail"+" -H \"Content-Type: application/json\" -H \"Authorization:  Basic "+Base64.getEncoder().encodeToString(auth.getBytes("utf-8"))+"\"";
		return Runtime.getRuntime().exec(shellcmd);
	}
}
